# -*- coding: utf-8 -*-
'''
DMenu is a TraitMenu subclass that was generated by the
scripts in dynmen/utils.
'''
from dynmen.common import TraitMenu, Flag, Option


class DMenu(TraitMenu):
    _aliases = [('fn', 'font'), ('i', 'case_insensitive'), ('p', 'prompt')]
    _base_command = ['dmenu']
    _version = 'dmenu-4.6'
    b = Flag('-b', help='dmenu appears at the bottom of the screen.')
    f = Flag(
        '-f',
        help='dmenu grabs the keyboard before reading stdin.  This is faster, but will lock up X until stdin reaches end-of-file.'
    )
    fn = Option('-fn', help='defines the font or font set used.')
    i = Flag('-i', help='dmenu matches menu items case insensitively.')
    l = Option('-l', help='dmenu lists items vertically, with the given number of lines.')
    m = Option(
        '-m',
        help='dmenu is displayed on the monitor number supplied. Monitor numbers are starting from 0.'
    )
    nb = Option(
        '-nb',
        help='defines the normal background color.  #RGB, #RRGGBB, and X color names are supported.'
    )
    nf = Option('-nf', help='defines the normal foreground color.')
    p = Option(
        '-p', help='defines the prompt to be displayed to the left of the input field.'
    )
    sb = Option('-sb', help='defines the selected background color.')
    sf = Option('-sf', help='defines the selected foreground color.')
    v = Flag('-v', help='prints version information to stdout, then exits.')

